Subject: Re: bug#11073: 24.0.94; BIDI-related crash in redisplay with certain byte sequences

From: Kenichi Handa <[email-masked]>
Date: Fri, 06 Apr 2012 10:13:12 +0900

In article <[email-masked]>, Stefan Monnier <[email-masked]> writes:

>>> But isn't this (unify-charset 'big5 "MyBig5.map") performed in the .emacs?
> > Usually yes.  But, in that case, if .emacs is encoded in
> > Big5 and it contains some Big5 PUA chars, they are not
> > unified while loading .emacs.

> Hmm... that doesn't sound like it would be a very common problem, but
> it's not completely hypothetical either.  Would this problem also come
> up in a BIG5 locale?  If not, then I think we can ignore this problem.

If it ever comes up, it is mostly for people in BIG5 locale.
But, please note that the reason I used BIG5 as an example
is just because that charset name is short.  Almost all CJK
charsets have PUA (officially or just by convention).

>>> Is it really important to support adding unification rules
>>> after decoding took place?  If so, why?
> > As I wrote, I can't tell how important it is.  It may be very
> > important for those (but I guess very few) who need the above
> > operation, but not important for the majority.
> > I'm ok to remove such a feature if the maintainers decide that.

> The problem with it is that it costs all the time for everyone, and it

I believe the extra cost is almost negligible because such
(dynamic) unification happens only for characters that is
greater than MAX_UNICODE_CHAR.

> makes the behavior of some macros subtly more complex/different and
> hence adds a nasty complexity.

That's mostly because I didn't write a proper comments on
the relavant macros, and didn't provide a better macros for
such a case as Eli's.

> So if at all possible, I'd rather find a way to remove it (not for
> 24.1, obviously).

I myself think that it doens't cause much problem even if we
keep this functionality, but, also don't raise strong
objection to remove it for 24.2.

>>> And also, what about removing unification rules after decoding?
> > When one tells Emacs to unify some chars, and then reads a file
> > containing those chars, there's no way to dis-unify them.

> But I guess this problem is even much less common.

Yes.  That's why I didn't implement such a feature.

---
Kenichi Handa
[email-masked]